package de.uni.leipzig.informatik.pacosy.cophylogeny.solver.cplex;

import java.io.File;
import java.lang.reflect.Field;

public class AbstractCplexSolver {

	static {
		try {
			String workdir = new File(".").getCanonicalPath();
			if (System.getProperty("os.name").toLowerCase().contains("windows")) {
				// try to load Windows library
				if (System.getProperty("os.arch").toLowerCase().contains("64")) {
					System.setProperty("java.library.path", System.getProperty("java.library.path")+":"+workdir+"/os/windows/x86_64");
				}
				else if (System.getProperty("os.arch").toLowerCase().contains("86")) {
					System.setProperty("java.library.path", System.getProperty("java.library.path")+":"+workdir+"/os/windows/x86");
				}
				else {
					System.out.println("The os and/or arch is not supported.");
				}
				
			}
			else if (System.getProperty("os.name").toLowerCase().contains("linux")) {
				// try to load Linux library
				if (System.getProperty("os.arch").toLowerCase().contains("64")) {
					System.setProperty("java.library.path", System.getProperty("java.library.path")+":"+workdir+"/os/linux/x86_64");
				}
				else if (System.getProperty("os.arch").toLowerCase().contains("86")) {
					System.setProperty("java.library.path", System.getProperty("java.library.path")+":"+workdir+"/os/linux/x86");
				}
				else {
					System.out.println("The os and/or arch is not supported.");
				}
			}
			else if (System.getProperty("os.name").toLowerCase().contains("mac")) {
				// try to load Mac library
				if (System.getProperty("os.arch").toLowerCase().contains("64")) {
					System.setProperty("java.library.path", System.getProperty("java.library.path")+":"+workdir+"/os/macosx/x86_64");
				}
				else if (System.getProperty("os.arch").toLowerCase().contains("86")) {
					System.setProperty("java.library.path", System.getProperty("java.library.path")+":"+workdir+"/os/macosx/x86");
				}
				else {
					System.out.println("The os and/or arch is not supported.");
				}
			} 
			else {
				System.out.println("The os and/or arch is not supported.");
			}
			Field fieldSysPath = ClassLoader.class.getDeclaredField( "sys_paths" );
			fieldSysPath.setAccessible( true );
			fieldSysPath.set( null, null );
			System.loadLibrary("cplex1260");
		} catch (Exception e) {
			System.out.println("The dynamic link library for CPLEX could not be"
									+ "loaded.\nConsider using\njava -Djava.library.path=");
			e.printStackTrace();
		}
	}
	
}
