package de.uni.leipzig.informatik.pacosy.datastructure.dao.factory;

import de.uni.leipzig.informatik.pacosy.datastructure.api.IEdge;
import de.uni.leipzig.informatik.pacosy.datastructure.api.INode;
import de.uni.leipzig.informatik.pacosy.datastructure.api.ITree;
import de.uni.leipzig.informatik.pacosy.datastructure.api.factory.ITreesFactory;
import de.uni.leipzig.informatik.pacosy.datastructure.dao.Edge;
import de.uni.leipzig.informatik.pacosy.datastructure.dao.Node;
import de.uni.leipzig.informatik.pacosy.datastructure.dao.Tree;

public class TreesFactory implements ITreesFactory{

	private static TreesFactory singleton;
	
	private TreesFactory(){}
	
	public static TreesFactory getSingleton(){
		if (singleton == null){
			singleton = new TreesFactory();
		}
		return singleton;
	}
	
	@Override
	public ITree createTree() {
		return new Tree();
	}

	@Override
	public INode createNode() {
		return new Node();
	}

	@Override
	public IEdge createEdge() {
		return new Edge();
	}
	
	@Override
	public Object createObject(String objectName) {
		if (objectName.equalsIgnoreCase("Tree")){
			return new Tree();
		} else if (objectName.equalsIgnoreCase("Node")){
			return new Node();
		} else if (objectName.equalsIgnoreCase("Edge")){
			return new Edge();
		} else {
			return null;
		}
	}

}
