package de.uni.leipzig.informatik.pacosy.datastructure.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;

import de.uni.leipzig.informatik.pacosy.datastructure.dao.Association;
import de.uni.leipzig.informatik.pacosy.datastructure.dao.Node;
import de.uni.leipzig.informatik.pacosy.datastructure.dao.Tanglegramm;

public class TanglegrammUtil {

	public static Node getLCA(Tanglegramm tanglegramm, Collection<Node> nodes) {
		Collection<Node> candidateLCSs = null;
		Iterator<Node> iterator = nodes.iterator();
		while (iterator.hasNext()) {
			Node node = iterator.next();
			Collection<Node> newCandidateLCSs = new ArrayList<Node>();
			do {
				if (candidateLCSs == null || candidateLCSs.contains(node)) {
					newCandidateLCSs.add(node);
				}
				node = node.getParent();
			} while (node != null);
			candidateLCSs = newCandidateLCSs;
		}

		return candidateLCSs==null?null:candidateLCSs.iterator().next();
	}

	public static Collection<Node> getConcurrentAssociatedSpecies(Tanglegramm tanglegramm, Node node) {
		Collection<Node> concurrentAssociatedSpecies = new HashSet<Node>();
		for (Association association : tanglegramm.getAssociations())	{
			Node associatedNode = null;
			if (association.getStrength()!=-1d){
				if (association.getPrimaryNode().equals(node))
					associatedNode = (Node)association.getSecondaryNode();
				else if (association.getSecondaryNode().equals(node))
					associatedNode = (Node)association.getPrimaryNode();
			}
			if (associatedNode!=null)
				concurrentAssociatedSpecies.add(associatedNode);
		}
		for (Node child : node.getChildren()) {
			concurrentAssociatedSpecies.addAll(TanglegrammUtil
					.getConcurrentAssociatedSpecies(tanglegramm, child));
		}
		return concurrentAssociatedSpecies;
	}

	public static Node getAssociatedLCA(Tanglegramm tanglegramm, Node node) {
		return TanglegrammUtil.getLCA(tanglegramm, TanglegrammUtil
				.getConcurrentAssociatedSpecies(tanglegramm, node));
	}
}
