package de.uni.leipzig.informatik.pacosy.nexus;

public class Token {

	String value;
	int line;
	int column;

	public Token(String value, int line, int column) {
		this.value = value;
		this.line = line;
		this.column = column;
	}

	public String getValue() {
		String result = value;
		if (result.length() >=2 && (result.matches("^(\".*\")|('.*')|(\\[.*\\])$"))){
			result=result.substring(1, result.length()-1);
		} else{
			result=result.replaceAll("_", " ");
		}
		return result;
	}

	public void setValue(String value) {
		this.value = value;
	}
	
	public String getPosition() {
		return "Line " + this.line + ", Column " + this.column;
	}

	public boolean isComment(){
		return value.startsWith("[") && value.endsWith("]");
	}

	@Override
	public String toString() {
		return value;
	}
	
	
}
