package de.uni.leipzig.informatik.pacosy.nexus.block.parser;

import de.uni.leipzig.informatik.pacosy.datastructure.dao.factory.CophylogenyFactory;
import de.uni.leipzig.informatik.pacosy.nexus.command.parser.NexusCophylogenyAssociationMatrixCommandParser;
import de.uni.leipzig.informatik.pacosy.nexus.command.parser.NexusCophylogenyAssociationsCommandParser;
import de.uni.leipzig.informatik.pacosy.nexus.command.parser.NexusCophylogenyPhiCommandParser;

public class NexusCophylogenyBlockParser extends DefaultNexusBlockParser {

	private static NexusCophylogenyBlockParser singleton;
	
	public static NexusCophylogenyBlockParser getSingleton(){
		if (singleton == null){
			singleton = new NexusCophylogenyBlockParser();
		}
		return singleton;
	}
	
	private NexusCophylogenyBlockParser() {
		super.registerCommandParser("ASSOCIATIONS", NexusCophylogenyAssociationsCommandParser.getSingleton());
		super.registerCommandParser("ASSOCIATIONMATRIX", NexusCophylogenyAssociationMatrixCommandParser.getSingleton());
		super.registerCommandParser("PHI", NexusCophylogenyPhiCommandParser.getSingleton());
		super.setDaoFactory(CophylogenyFactory.getSingleton());
	}
	
}
