package de.uni.leipzig.informatik.pacosy.nexus.block.parser;

import de.uni.leipzig.informatik.pacosy.datastructure.api.factory.ITreesFactory;
import de.uni.leipzig.informatik.pacosy.datastructure.dao.factory.TreesFactory;
import de.uni.leipzig.informatik.pacosy.nexus.command.parser.NexusMapOfStringsStyleCommandParser;
import de.uni.leipzig.informatik.pacosy.nexus.command.parser.NexusTreeCommandParser;

public class NexusTreesBlockParser extends DefaultNexusBlockParser {

	private static NexusTreesBlockParser singleton;
	
	public static NexusTreesBlockParser getSingleton(){
		if (singleton == null){
			singleton = new NexusTreesBlockParser();
		}
		return singleton;
	}
	
	private NexusTreesBlockParser() {
		super.registerCommandParser("TRANSLATE", NexusMapOfStringsStyleCommandParser.getSingleton());
		super.registerCommandParser("TREE", NexusTreeCommandParser.getSingleton());
		super.setDaoFactory(TreesFactory.getSingleton());
	}
	
	@Override
	public ITreesFactory getDaoFactory() {
		return (ITreesFactory)super.getDaoFactory();
	}
	
}
